;@echo off
copy /b sg.snd+sg.snd sg4k.snd > nul
echo Preparing Robotron...
robotest | find "FAILURE" > nul
if not errorlevel 1 goto ERROR

:PATCHROBO
copy /b robotron.sb1+robotron.sb2+robotron.sb3+robotron.sb4+robotron.sb5+robotron.sb6 robo1.bin >nul
copy /b robotron.sb7+robotron.sb8+robotron.sb9+blank.4k+blank.4k+blank.4k robo2.bin >nul
copy /b blank.4k+robotron.sba+robotron.sbb+robotron.sbc robo3.bin >nul
copy /b robo1.bin+robo2.bin+robo3.bin robotron.bin >nul
del robo1.bin >nul
del robo2.bin >nul
del robo3.bin >nul

patcher1 robotron.bin robo_pat.pat | find "SUCCESS" >nul
if errorlevel 1 goto ERROR3

:JOUST
echo Preparing Joust...
joustest | find "FAILURE" > nul
if not errorlevel 1 goto ERROR4

copy /b joust.wg1+joust.wg2+joust.wg3+joust.sr4+joust.wg5+joust.sr6 jous1.bin >nul
copy /b joust.sr7+joust.sr8+joust.sr9+blank.4k+blank.4k+blank.4k jous2.bin >nul
copy /b blank.4k+joust.sra+joust.srb+joust.src jous3.bin >nul
copy /b jous1.bin+jous2.bin+jous3.bin joust.bin >nul
del jous1.bin >nul
del jous2.bin >nul
del jous3.bin >nul


:BUBBLES
echo Preparing Bubbles...
bubltest | find "FAILURE" > nul
if not errorlevel 1 goto ERROR5

copy /b bubbles.1b+bubbles.2b+bubbles.3b+bubbles.4b+bubbles.5b+bubbles.6b bubl1.bin >nul
copy /b bubbles.7b+bubbles.8b+bubbles.9b+blank.4k+blank.4k+blank.4k bubl2.bin >nul
copy /b blank.4k+bubbles.10b+bubbles.11b+bubbles.12b bubl3.bin >nul
copy /b bubl1.bin+bubl2.bin+bubl3.bin bubbles.bin >nul
del bubl1.bin >nul
del bubl2.bin >nul
del bubl3.bin >nul


:SPLAT
echo Preparing Splat...
splatest | find "FAILURE" > nul
if not errorlevel 1 goto ERROR7

:PATCHSPLAT
copy /b splat.01+splat.02+splat.03+splat.04+splat.05+splat.06 spla1.bin >nul
copy /b splat.07+splat.08+splat.09+blank.4k+blank.4k+blank.4k spla2.bin >nul
copy /b blank.4k+splat.10+splat.11+splat.12 spla3.bin >nul
copy /b spla1.bin+spla2.bin+spla3.bin splat.bin >nul
del spla1.bin >nul
del spla2.bin >nul
del spla3.bin >nul

patcher1 splat.bin splat.pat | find "SUCCESS" >nul
if errorlevel 1 goto ERROR6

:STARGATE
echo Preparing Stargate...
startest | find "FAILURE" > nul
if not errorlevel 1 goto ERROR8

copy /b 01+02+03+04+05+06 star1.bin >nul
copy /b 07+08+09+blank.4k+blank.4k+blank.4k star2.bin >nul
copy /b blank.4k+10+11+12 star3.bin >nul
copy /b star1.bin+star2.bin+star3.bin stargate.bin >nul
del star1.bin >nul
del star2.bin >nul
del star3.bin >nul


:DEFENDER
echo Preparing Defender...
defntest | find "FAILURE" > nul
if not errorlevel 1 goto ERROR9

:PATCHDEFN
copy /b blank.4k+blank.4k+blank.4k+blank.4k defn1.bin >nul
copy /b defn1.bin+defn1.bin+defend.9+defend.12+defend.8+defend.11 defn2.bin >nul
copy /b defend.7+defend.10+defend.6+blank.6k+defend.1+defend.4 defn3.bin >nul
copy /b defn2.bin+defn3.bin+defend.2+defend.3 defender.bin >nul
del defn1.bin > nul
del defn2.bin > nul
del defn3.bin >nul

patcher1 defender.bin defend.pat | find "SUCCESS" >nul
if errorlevel 1 goto ERROR10

:SOUNDS
copy /b robotron.snd+robotron.snd+joust.snd+sg4k.snd+bubbles.snd+defend.snd+defend.snd+splat.snd+bubbles.snd snd_32k.bin > nul

:PROGRAMS
copy /b menu+robotron.bin+joust.bin+stargate.bin+bubbles.bin+defender.bin+splat.bin+bubbles.bin rom_512K.bin > nul

del robotron.bin > nul
del stargate.bin > nul
del joust.bin > nul
del splat.bin > nul
del bubbles.bin > nul
del defender.bin > nul

dir *.bin

goto DONE

:ERROR
robotest

:ERROR2
echo An error occurred.  You will need to correct the problem above and try again.
goto END

:ERROR3
echo There was an error patching the ROM.  Be sure that "robo_pat.pat" is in
echo the directory.
goto END

:ERROR4
joustest
goto ERROR2

:ERROR5
bubltest
goto ERROR2

:ERROR6
echo There was an error patching the ROM.  Be sure that "splat.pat" is in
echo the directory.
goto END

:ERROR7
splatest
goto ERROR2

:ERROR8
startest
goto ERROR2

:ERROR9
defntest
goto ERROR2

:ERROR10
echo There was an error patching the ROM.  Be sure that "defend.pat" is in
echo the directory.
goto END

:DONE
echo All ROMs were generated OK.
:END
